H5W3
当前位置:H5W3 > 其他技术问题 > 正文

python连oanda的模拟交易api获取json问题第五问

在正常工作1个多小时后有时突然停止工作没有任何报错,或者报错requests.packages.urllib3.exceptions.ProtocolError: (‘Connection aborted.’, BadStatusLine(“””,)),网上其他地方有的说是超时、有的说是说连的是https、有的说要换成python3.5或以上(我用的是python3.4)

程序就是原来上几问中的程序再加个while True :的循环,谢谢

程序:

import requests
import json

url = "https://api-fxpractice.oanda.com/v1/prices"

instruments = 'EUR_USD,USD_CAD'
account_id = 'cawa11'
params = {'instruments':instruments,'accountId':account_id}

access_token = 'a554db3a48ac8180a6996a5547ba1663-ac5947e64456cc5842a34f4ce05e4380' 
headers = {'Connection': 'Keep-Alive',
           'Accept-Encoding': 'gzip,deflate',
           'Authorization':'Bearer '+access_token}    #Bearer后有空格

while True :
    r = requests.get(url,headers = headers, params=params) 
    price = r.json()
    print(r.json())
    print(price['prices'][0]['instrument'].replace('_','/'),':',round((price['prices'][0]['ask']+price['prices'][0]['bid'])/2,4),'  ',price['prices'][0]['time'])
    print(price['prices'][1]['instrument'].replace('_','/'),':',round((price['prices'][1]['ask']+price['prices'][1]['bid'])/2,4),'  ',price['prices'][1]['time'])

报错信息:

Traceback (most recent call last):
  File "C:\Python34\lib\site-packages\requests-2.9.1-py3.4.egg\requests\packages\urllib3\connectionpool.py", line 554, in urlopen
    self._prepare_proxy(conn)
  File "C:\Python34\lib\site-packages\requests-2.9.1-py3.4.egg\requests\packages\urllib3\connectionpool.py", line 750, in _prepare_proxy
    conn.connect()
  File "C:\Python34\lib\site-packages\requests-2.9.1-py3.4.egg\requests\packages\urllib3\connection.py", line 230, in connect
    self._tunnel()
  File "C:\Python34\lib\http\client.py", line 815, in _tunnel
    (version, code, message) = response._read_status()
  File "C:\Python34\lib\http\client.py", line 321, in _read_status
    raise BadStatusLine(line)
http.client.BadStatusLine: ''

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "C:\Python34\lib\site-packages\requests-2.9.1-py3.4.egg\requests\adapters.py", line 376, in send
    timeout=timeout
  File "C:\Python34\lib\site-packages\requests-2.9.1-py3.4.egg\requests\packages\urllib3\connectionpool.py", line 609, in urlopen
    _stacktrace=sys.exc_info()[2])
  File "C:\Python34\lib\site-packages\requests-2.9.1-py3.4.egg\requests\packages\urllib3\util\retry.py", line 247, in increment
    raise six.reraise(type(error), error, _stacktrace)
  File "C:\Python34\lib\site-packages\requests-2.9.1-py3.4.egg\requests\packages\urllib3\packages\six.py", line 309, in reraise
    raise value.with_traceback(tb)
  File "C:\Python34\lib\site-packages\requests-2.9.1-py3.4.egg\requests\packages\urllib3\connectionpool.py", line 554, in urlopen
    self._prepare_proxy(conn)
  File "C:\Python34\lib\site-packages\requests-2.9.1-py3.4.egg\requests\packages\urllib3\connectionpool.py", line 750, in _prepare_proxy
    conn.connect()
  File "C:\Python34\lib\site-packages\requests-2.9.1-py3.4.egg\requests\packages\urllib3\connection.py", line 230, in connect
    self._tunnel()
  File "C:\Python34\lib\http\client.py", line 815, in _tunnel
    (version, code, message) = response._read_status()
  File "C:\Python34\lib\http\client.py", line 321, in _read_status
    raise BadStatusLine(line)
requests.packages.urllib3.exceptions.ProtocolError: ('Connection aborted.', BadStatusLine("''",))

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "C:\Users\lenovo\Desktop\hh.py", line 27, in <module>
    r = requests.get(url,headers = headers, params=params)
  File "C:\Python34\lib\site-packages\requests-2.9.1-py3.4.egg\requests\api.py", line 67, in get
    return request('get', url, params=params, **kwargs)
  File "C:\Python34\lib\site-packages\requests-2.9.1-py3.4.egg\requests\api.py", line 53, in request
    return session.request(method=method, url=url, **kwargs)
  File "C:\Python34\lib\site-packages\requests-2.9.1-py3.4.egg\requests\sessions.py", line 468, in request
    resp = self.send(prep, **send_kwargs)
  File "C:\Python34\lib\site-packages\requests-2.9.1-py3.4.egg\requests\sessions.py", line 576, in send
    r = adapter.send(request, **kwargs)
  File "C:\Python34\lib\site-packages\requests-2.9.1-py3.4.egg\requests\adapters.py", line 426, in send
    raise ConnectionError(err, request=request)
requests.exceptions.ConnectionError: ('Connection aborted.', BadStatusLine("''",))

按@prolifes说的进行修改后出现的新的报错信息:
Traceback (most recent call last):
File “C:Python34libsite-packagesrequests-2.9.1-py3.4.eggrequestspackagesurllib3connectionpool.py”, line 559, in urlopen

body=body, headers=headers)

File “C:Python34libsite-packagesrequests-2.9.1-py3.4.eggrequestspackagesurllib3connectionpool.py”, line 345, in _make_request

self._validate_conn(conn)

File “C:Python34libsite-packagesrequests-2.9.1-py3.4.eggrequestspackagesurllib3connectionpool.py”, line 784, in _validate_conn

conn.connect()

File “C:Python34libsite-packagesrequests-2.9.1-py3.4.eggrequestspackagesurllib3connection.py”, line 252, in connect

ssl_version=resolved_ssl_version)

File “C:Python34libsite-packagesrequests-2.9.1-py3.4.eggrequestspackagesurllib3utilssl_.py”, line 305, in ssl_wrap_socket

return context.wrap_socket(sock, server_hostname=server_hostname)

File “C:Python34libssl.py”, line 365, in wrap_socket

_context=self)

File “C:Python34libssl.py”, line 583, in init

self.do_handshake()

File “C:Python34libssl.py”, line 810, in do_handshake

self._sslobj.do_handshake()

TimeoutError: [WinError 10060] 由于连接方在一段时间后没有正确答复或连接的主机没有反应,连接尝试失败。

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
File “C:Python34libsite-packagesrequests-2.9.1-py3.4.eggrequestsadapters.py”, line 376, in send

timeout=timeout

File “C:Python34libsite-packagesrequests-2.9.1-py3.4.eggrequestspackagesurllib3connectionpool.py”, line 609, in urlopen

_stacktrace=sys.exc_info()[2])

File “C:Python34libsite-packagesrequests-2.9.1-py3.4.eggrequestspackagesurllib3utilretry.py”, line 247, in increment

raise six.reraise(type(error), error, _stacktrace)

File “C:Python34libsite-packagesrequests-2.9.1-py3.4.eggrequestspackagesurllib3packagessix.py”, line 309, in reraise

raise value.with_traceback(tb)

File “C:Python34libsite-packagesrequests-2.9.1-py3.4.eggrequestspackagesurllib3connectionpool.py”, line 559, in urlopen

body=body, headers=headers)

File “C:Python34libsite-packagesrequests-2.9.1-py3.4.eggrequestspackagesurllib3connectionpool.py”, line 345, in _make_request

self._validate_conn(conn)

File “C:Python34libsite-packagesrequests-2.9.1-py3.4.eggrequestspackagesurllib3connectionpool.py”, line 784, in _validate_conn

conn.connect()

File “C:Python34libsite-packagesrequests-2.9.1-py3.4.eggrequestspackagesurllib3connection.py”, line 252, in connect

ssl_version=resolved_ssl_version)

File “C:Python34libsite-packagesrequests-2.9.1-py3.4.eggrequestspackagesurllib3utilssl_.py”, line 305, in ssl_wrap_socket

return context.wrap_socket(sock, server_hostname=server_hostname)

File “C:Python34libssl.py”, line 365, in wrap_socket

_context=self)

File “C:Python34libssl.py”, line 583, in init

self.do_handshake()

File “C:Python34libssl.py”, line 810, in do_handshake

self._sslobj.do_handshake()

requests.packages.urllib3.exceptions.ProtocolError: (‘Connection aborted.’, TimeoutError(10060, ‘由于连接方在一段时间后没有正确答复或连接的主机没有反应,连接尝试失败。’, None, 10060, None))

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
File “C:UserslenovoDesktopii.py”, line 30, in run

r = requests.get(url,headers = headers, params=params)

File “C:Python34libsite-packagesrequests-2.9.1-py3.4.eggrequestsapi.py”, line 67, in get

return request('get', url, params=params, **kwargs)

File “C:Python34libsite-packagesrequests-2.9.1-py3.4.eggrequestsapi.py”, line 53, in request

return session.request(method=method, url=url, **kwargs)

File “C:Python34libsite-packagesrequests-2.9.1-py3.4.eggrequestssessions.py”, line 468, in request

resp = self.send(prep, **send_kwargs)

File “C:Python34libsite-packagesrequests-2.9.1-py3.4.eggrequestssessions.py”, line 576, in send

r = adapter.send(request, **kwargs)

File “C:Python34libsite-packagesrequests-2.9.1-py3.4.eggrequestsadapters.py”, line 426, in send

raise ConnectionError(err, request=request)

requests.exceptions.ConnectionError: (‘Connection aborted.’, TimeoutError(10060, ‘由于连接方在一段时间后没有正确答复或连接的主机没有反应,连接尝试失败。’, None, 10060, None))

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
File “C:UserslenovoDesktopii.py”, line 133, in <module>

run()

File “C:UserslenovoDesktopii.py”, line 128, in run

print(traceback.format_exc())

NameError: name ‘traceback’ is not defined

回答:

把关键代码封装成函数,并加上错误处理,保证while true不中断,同时打印信息去排查

# coding: utf-8

import requests
import json
import traceback

def run():
    try:
        url = "https://api-fxpractice.oanda.com/v1/prices"
        instruments = 'EUR_USD,USD_CAD'
        account_id = 'cawa11'
        params = {'instruments':instruments,'accountId':account_id}
        
        access_token = 'a554db3a48ac8180a6996a5547ba1663-ac5947e64456cc5842a34f4ce05e4380' 
        headers = {'Connection': 'Keep-Alive',
                   'Accept-Encoding': 'gzip,deflate',
                   'Authorization':'Bearer '+access_token}    #Bearer后有空格
    
        r = requests.get(url,headers = headers, params=params) 
        price = r.json()
        print(r.json())
        print(price['prices'][0]['instrument'].replace('_','/'),':',round((price['prices'][0]['ask']+price['prices'][0]['bid'])/2,4),'  ',price['prices'][0]['time'])
        print(price['prices'][1]['instrument'].replace('_','/'),':',round((price['prices'][1]['ask']+price['prices'][1]['bid'])/2,4),'  ',price['prices'][1]['time'])
    except:
        print traceback.format_exc()

if __name__ == '__main__':
    while True:
        run()

回答:

在@prolifes的帮助下问题已解决,程序如下:

coding: utf-8

import requests
import json
import traceback

def run():

try:
    url = "https://api-fxpractice.oanda.com/v1/prices"
    instruments = 'EUR_USD,USD_CAD'
    account_id = 'cawa11'
    params = {'instruments':instruments,'accountId':account_id}
    
    access_token = 'a554db3a48ac8180a6996a5547ba1663-ac5947e64456cc5842a34f4ce05e4380' 
    headers = {'Connection': 'Keep-Alive',
               'Accept-Encoding': 'gzip,deflate',
               'Authorization':'Bearer '+access_token}    #Bearer后有空格

    r = requests.get(url,headers = headers, params=params,timeout=5) 
    price = r.json()
    print(r.json())
    print(price['prices'][0]['instrument'].replace('_','/'),':',round((price['prices'][0]['ask']+price['prices'][0]['bid'])/2,4),'  ',price['prices'][0]['time'])
    print(price['prices'][1]['instrument'].replace('_','/'),':',round((price['prices'][1]['ask']+price['prices'][1]['bid'])/2,4),'  ',price['prices'][1]['time'])
except:
    #print traceback.format_exc()
    pass

if name == ‘__main__’:

while True:
    run()

本文地址:H5W3 » python连oanda的模拟交易api获取json问题第五问

评论 0

  • 昵称 (必填)
  • 邮箱 (必填)
  • 网址